unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TimeThr, ExtCtrls;

type
  TMainForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    StaticText1: TStaticText;
    NumThreads: TStaticText;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private-Deklarationen }
    t: Array[1..10] of TTimeThread;
    NextResume, NextSuspend: Integer;
    tid: Integer;
    Suspend: Boolean;
    Count : Integer;
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  for i:=1 to 10 do t[i] := TTimeThread.Create(true);
  NextResume := 1;
  NextSuspend := 0;
  tid := 0; Suspend := false;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: Integer;
begin
  for i:=1 to 10 do
  begin
    if t[i].Suspended then t[i].Resume;
    t[i].Terminate;
    t[i].Waitfor;
    t[i].Destroy;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if NextResume > 10 then Exit;
  t[NextResume].Resume;
  Inc(NextSuspend); Inc(NextResume);
  NumThreads.Caption := IntToStr(NextSuspend);
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  If NextSuspend = 0 then Exit;
  t[NextSuspend].Suspend;
  Dec(NextSuspend); Dec(NextResume);
  NumThreads.Caption := IntToStr(NextSuspend);
end;

procedure TMainForm.Button3Click(Sender: TObject);
var
  t: TStartupInfo;
  p: TProcessInformation;
  Res: Boolean;
  ps: String;
begin
  FillChar(t, sizeof(TStartupInfo), 0);
  t.cb := sizeof(TStartupInfo);
  t.lpReserved := NIL;
  t.lpDesktop := NIL;
  ps := 'Schnecke Console';
  t.lpTitle := PChar(ps);
  Res := CreateProcess(NIL, 'C:\WIN\COMMAND.COM',NIL,NIL,FALSE,
    CREATE_DEFAULT_ERROR_MODE or CREATE_NEW_CONSOLE or CREATE_SEPARATE_WOW_VDM
    or IDLE_PRIORITY_CLASS, NIL, NIL, t, p);
    tid := p.hThread;
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
  SuspendThread(tid);
end;

end.
